
# Define a variable
x = 10

# Arithmetic operations
y = x + 5
z = x * y

# IO.print to show values
IO.puts("x: #{x}")
IO.puts("y: #{y}")
IO.puts("z: #{z}")


# Define an anonymous function that adds two numbers
adder = fn a, b -> a + b end

# Call the anonymous function
IO.puts(adder.(y, z))  # Prints: 165


# Define and call an anonymous function in the same expression
IO.puts(fn a, b -> a + b end.(5, 8))  # Prints: 13


# Conditional statement
if z > 100 do
  IO.puts("z is greater than 100")
else
  IO.puts("z is less than or equal to 100")
end

# A list and accessing elements
list = [1, 2, 3, 4, 5]
IO.puts("First element in list: #{hd(list)}")   # head of list
IO.puts("Rest of the list: #{tl(list)}")         # tail of list

# Using Enum functions
squared_list = Enum.map(list, fn x -> x * x end)
IO.puts("Squared list: #{inspect(squared_list)}")

# List comprehension
even_squares = for x <- list, rem(x, 2) == 0, do: x * x
IO.puts("Even numbers squared: #{inspect(even_squares)}")

# Pattern matching
{a, b, c} = {1, 2, 3}
IO.puts("a: #{a}, b: #{b}, c: #{c}")

# Handling a tuple
tuple = {:ok, "Success"}
IO.puts("Tuple first element: #{elem(tuple, 0)}")
IO.puts("Tuple second element: #{elem(tuple, 1)}")

# A map and accessing a value
map = %{name: "Alice", age: 30}
IO.puts("Name: #{map[:name]}")
IO.puts("Age: #{map[:age]}")

# Create and manipulate a string
greeting = "Hello"
name = "World"
full_greeting = "#{greeting}, #{name}!"
IO.puts("Greeting: #{full_greeting}")

# Create a range and iterate over it
range = 1..5
Enum.each(range, fn n -> IO.puts("Number: #{n}") end)

# Working with date
date = Date.utc_today()
IO.puts("Today's date: #{date}")

IO.puts("End of script")

