

defmodule SSV do  # stack server

  def new do
    pid = spawn_link(__MODULE__, :loop, [[]])
    {:ok, pid}
  end
  def push(pid, item) do send( pid, {:push, item} ) end
  def pop(pid) do send( pid, {:pop} ) end
  def size(pid) do
    send( pid, {:size, self()} )
    receive do {:ok, size} -> size end
  end
  def top(pid) do 
    send( pid, {:top, self()} ) 
    receive do {:ok, item} -> item end
  end

  def loop(stack) do
    receive do
      {:push, item} -> 
        loop([item|stack])
      {:pop} -> 
        if stack == [] do loop(stack) end
        loop(tl(stack))
      {:top, sender} ->
        if stack == [] do send(sender, {:ok, nil})
        else send(sender, {:ok, hd(stack)})
        end
        loop(stack)
      {:size, sender} ->
        send(sender, {:ok, Enum.count(stack)})
        loop(stack)
    end
  end

end

